###
## SecClabRa
## Copyright (C) 2003 SecClab group (mail. lfp70@hotmail.com)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public Licence as published by
# the Free Software Foundation; eihter version 2 of the License, or
# (at your option) any later version.
#
# This program is distributes in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
##

from Globals import DTMLFile,InitializeClass,HTML
from AccessControl import ClassSecurityInfo
from OFS.PropertyManager import PropertyManager
from OFS.SimpleItem import SimpleItem
from ZPublisher.HTTPRequest import HTTPRequest
from ZPublisher import BeforeTraverse

import OpensslWrapper
from SecClabCa import MessageDialog

from zExceptions import Unauthorized

import sys,traceback
from urllib import quote

PasswordDialog = HTML("""
<HTML>
<HEAD>
<TITLE>TYPE YOUR PASSWORD</TITLE>
</HEAD>
<BODY>
<FORM ACTION="<dtml-var action>" METHOD="POST" <dtml-if target>TARGET="<dtml-var target>"</dtml-if>>
 <dtml-in cgi_values prefix="lis">
   <INPUT type="hidden" name="<dtml-var expr="lis_item[0]">" value="<dtml-var expr="lis_item[1]">">
 </dtml-in>
 <TABLE BORDER="0" WIDTH="70%" CELLPADDING="10" ALIGN="CENTER">
 <TR>
   <TD align="center">TYPE CERTIFICATION AUTHORITY PASSWORD
   </TD>
 </TR>
 <TR>
   <TD align="center">Password: <INPUT type="password" name="password"></TD>
 </TR>
  <TR>
    <TD VALIGN="TOP" align="center">
      <INPUT TYPE="SUBMIT" VALUE="   Ok   ">
    </TD>
  </TR>
  </TABLE>
</FORM>
</BODY>
</HTML>
""",target="",action="manage_main",cgi_values=())


manage_addSecClabAccessForm = DTMLFile('dtml/manage_addSecClabAccessForm',globals())

def manage_addSecClabAccess(self, id,
                            title='',
                            session_variable='SecClabAccessPassword',
                            REQUEST=None):
    """ Add a new SecClabAccess to current ObjectManager """
    acc = SecClabAccess('AA',title,session_variable)
    try:
        self._setObject('AA',acc)
    except: return MessageDialog(
        title  ='Item Exists',
        message='This object already contains an Access',
        action ='%s/manage_main' % REQUEST['URL1'])
    
    acc = self._getOb('AA')

    if REQUEST:
        return self.manage_main(self,REQUEST,update_menu=1)



class SecClabAccess(PropertyManager, SimpleItem):
    meta_type = 'SecClab Access'
                                                                                                                             
    security = ClassSecurityInfo()
    # security.declareProtected(ModifyCookieCrumblers,
    #                           'manage_editProperties',
    #                           'manage_changeProperties')
    # security.declareProtected(Permissions.view_management_screens,
    #                           'manage_propertiesForm')
                                                                                                                             
                                                                                                                             
    _properties = ({'id':'session_variable', 'type': 'string', 'mode':'w',
                    'label':'Authentication cookie name'},
                   )
                                                                                                                             
    def __init__(self,id,title,session_variable='SecClabAccessPassword'):
        """ setup a SecClabAccess """
        self.id = id
        self.title = title
        self.session_variable = session_variable

    def __call__(self,container,req):
      try:
        if self.ca_generated == 0:
            return
        if req.__class__ is not HTTPRequest:
            return 
                                                                                                                             
        if not req[ 'REQUEST_METHOD' ] in ( 'GET', 'PUT', 'POST' ):
            return

        resp = self.REQUEST['RESPONSE']
        print req['TraversalRequestNameStack']
        if len(req['TraversalRequestNameStack']) > 1 and req['TraversalRequestNameStack'][-1] == 'virtual_hosting':
           print "NADA"
           return

        if not req.SESSION.has_key(self.session_variable):
            if ('manage_secClabSetPassword' in req['TraversalRequestNameStack']) or ('login' in req['TraversalRequestNameStack']):
                return
            else:
                #resp.setHeader('Content-Type',"text/html");
                #resp.write(PasswordDialog(action="manage_secClabSetPassword"));
                #req['TraversalRequestNameStack'] = []
                req._hold(ResponseCleanup(resp))
                resp.unauthorized = self.unauthorized
                resp._unauthorized = self._unauthorized
                raise Unauthorized,"Unauthorized"
        else:
            if OpensslWrapper.CheckCAPassword(self.dir,req.SESSION[self.session_variable]) == 0:
                if 'manage_secClabSetPassword' in req['TraversalRequestNameStack']:
                    return
                #resp.setHeader('Content-Type',"text/html")
                #resp.write(PasswordDialog(action="manage_secClabSetPassword"));
                #req['TraversalRequestNameStack'] = []
                req._hold(ResponseCleanup(resp))
                resp.unauthorized = self.unauthorized
                resp._unauthorized = self._unauthorizeda
                raise Unauthorized,"Unauthorized"
      except Unauthorized:
        ec, e, tb = sys.exc_info()
        traceback.print_tb(tb)
        raise
      except:
        ec, e, tb = sys.exc_info()
        traceback.print_tb(tb)
        raise Unauthorized,"Unauthorized"

    security.declarePublic('login')
    def login(self,REQUEST):
        """ LOGIN """
        return PasswordDialog(action="manage_secClabSetPassword");

    security.declarePublic('getLoginURL')
    def getLoginURL(self):
        req = self.REQUEST
        resp = req['RESPONSE']
        iself = getattr(self, 'aq_inner', self)
        #parent = getattr(iself, 'aq_parent', None)
        #page = getattr(parent, self.auto_login_page, None)
        page = iself
        retry = getattr(resp, '_auth', 0) and '1' or ''
        came_from = req.get('came_from', None)
        if came_from is None:
            came_from = req['URL']
        url = '%s/login?came_from=%s&retry=%s' % (page.absolute_url(), quote(came_from), retry)
        return url

    def _cleanupResponse(self):
        resp = self.REQUEST['RESPONSE']
        try: del resp.unauthorized
        except: pass
        try: del resp._unauthorized
        except: pass
        return resp

    security.declarePrivate('unauthorized')
    def unauthorized(self):
        print "unauth"
        resp = self._cleanupResponse()
        #resp.setHeader('Content-Type',"text/html")
        #resp.write(PasswordDialog(action="manage_secClabSetPassword"))
        #raise Unauthorized,PasswordDialog(action="manage_secClabSetPassword")
        url = self.getLoginURL()
        raise 'Redirect',url

    def _unauthorized(self):
        print "_unaht"
        resp = self._cleanupResponse()
        #resp.setHeader('Content-Type',"text/html")
        #resp.write(PasswordDialog(action="manage_secClabSetPassword"))
        url = self.getLoginURL()
        resp.redirect(url, lock=1)



    def manage_beforeDelete(self, item, container):
        if item is self:
            handle = self.meta_type + '/' + self.getId()
            BeforeTraverse.unregisterBeforeTraverse(container, handle)
                                                                                                                             
    def manage_afterAdd(self, item, container):
        if item is self:
            handle = self.meta_type + '/' + self.getId()
            container = container.this()
            nc = BeforeTraverse.NameCaller(self.getId())
            BeforeTraverse.registerBeforeTraverse(container, nc, handle)


InitializeClass(SecClabAccess)

class ResponseCleanup:
    def __init__(self, resp):
        self.resp = resp

    def __del__(self):
        # Free the references.
        try: del self.resp.unauthorized
        except: pass
        try: del self.resp._unauthorized
        except: pass
        try: del self.resp
        except: pass

